#property copyright "Copyright 2020, Mathematic Trading."
#property link      "http://www.mathematictrading.com"
#property version   "1.00"
#property strict

#property indicator_chart_window  // I'm not sure what this is for.  Does this just open the MACD window? Does that window have to be open?
//This is just for the indicator to be drawn on the chart window; otherwise, you need to use #property indicator_separate_window
//with separate window, you are just going to have indicators drawn like RSI, oscilators or similar
#property indicator_buffers 3
#property indicator_color1  Red

extern string ____________________________________________________________ms="++++++++++ MACD Settings ++++++++++";
extern int fast_ema_period=12;//Fast EMA Period  
extern int slow_ema_period=26;//Slow EMA Period
extern int signal_period=9;//Signal Period

double Peak[];
double up[],dn[];

int init(){
   IndicatorBuffers(3);  // A buffer is an array for each line used in an indicator?  Could you explain the SetIndex area below?
   //Buffer are the values used for the indicator to be shown in the DATA (you may use less, more or none, that's depending on the DATA you need.
   
   SetIndexBuffer(0,Peak); //Naming the buffer array
   SetIndexStyle (0, DRAW_SECTION);//Type of drawn, this case we need "zig zag" type
   SetIndexEmptyValue(0,0.0);//Just setting the empty
   
   
   SetIndexBuffer(1,up); 
   SetIndexStyle (1, DRAW_NONE);
   SetIndexEmptyValue(1,0.0);
   
   SetIndexBuffer(2,dn); 
   SetIndexStyle (2, DRAW_NONE);
   SetIndexEmptyValue(2,0.0);

   return(0);
}

// Remove the lines that were drawn with the indicator when the indicator is removed.

int deinit(){
for(int i=ObjectsTotal()-1;i>=0;i--)
   if(StringFind(ObjectName(i),"Line",0)!=-1) ObjectDelete(ObjectName(i));
   return(0);
}

// Create the global variables
datetime PrevBullish=0;
datetime PrevBearish=0;

// Run the Indicator
int start(){
   int counted_bars=IndicatorCounted(); // IndicatorCounted counts how many bars the indicator has gone over so far?
   //Yes, to avoid extra calculations. Sometimes you need to go over previous bars, sometimes no. This entry just indicates 0 if the indicator
   //has started, or the number of new bars the indicator has not calculated. For example, if you have the indicator running and you lose internet connection
   //after X bars you gain the connection, then this value will say the indicator than there are new X bars than has not been calculated yet
   if(counted_bars < 0) return(-1);
   int limit = Bars - counted_bars;  // This determines how many bars back the indicator will cover?
   //Yeah; the line bellow it's just something I add because that way, I avoid posible bugs you can have near the firsts bars of the chart. 
   //if you have indicators with periods 200 for example, I recommend you to remplace 10 by 200, because that way, the first 200 bars, when 
   //starting, won't be calculated.
   if(limit>Bars-10) limit=Bars-10;

   for(int i=limit;i>0;i--){
      double MacdMain=iMACD(NULL,0,fast_ema_period,slow_ema_period,signal_period,PRICE_CLOSE,MODE_MAIN,i);
      double MacdMain_1=iMACD(NULL,0,fast_ema_period,slow_ema_period,signal_period,PRICE_CLOSE,MODE_MAIN,i+1);
      double MacdSignal=iMACD(NULL,0,fast_ema_period,slow_ema_period,signal_period,PRICE_CLOSE,MODE_SIGNAL,i);
      double MacdSignal_1=iMACD(NULL,0,fast_ema_period,slow_ema_period,signal_period,PRICE_CLOSE,MODE_SIGNAL,i+1);
      
      bool NewZone=false;
      
      // MACD crosses up
      if(MacdMain>MacdSignal && MacdMain_1<MacdSignal_1){
         PrevBullish=Time[i];    //PrevBullish/PrevBearish are global variables so they can be used in different IF loops.
         NewZone=true;
      }
      
      // MACD crosses down
      if(MacdMain<MacdSignal && MacdMain_1>MacdSignal_1){
         PrevBearish=Time[i];
         NewZone=true;
      }
      
      // Finding peaks
      if(NewZone){   // Every time NewZone is true, PrevBullish & PrevBearish have a new value. Between each new value the HH or LL are located.
         int Peak_Bar=0;
         
         if(PrevBullish<PrevBearish){
            int j=iBarShift(NULL,0,PrevBearish,false);
            int k=iBarShift(NULL,0,PrevBullish,false);
            Peak_Bar=iHighest(NULL,0,MODE_HIGH,k-j,j);
            Peak[Peak_Bar]=High[Peak_Bar];
            up[Peak_Bar]=Peak[Peak_Bar];
         }
         
         if(PrevBullish>PrevBearish){
            int j=iBarShift(NULL,0,PrevBullish,false);
            int k=iBarShift(NULL,0,PrevBearish,false);
            Peak_Bar=iLowest(NULL,0,MODE_LOW,k-j,j);
            Peak[Peak_Bar]=Low[Peak_Bar];
            dn[Peak_Bar]=Peak[Peak_Bar];
         }
         
      }
   }

 return(0);  
}


/*
   START:
   
   int counted_bars=IndicatorCounted(); 
   if(counted_bars < 0) return(-1);
   int limit = Bars - counted_bars; 
   if(limit>Bars-10) limit=Bars-10;

   for(int i=limit;i>0;i--){
   //WHATEVER FUNCTION YOU WANT TO USE INSIDE THE INDICATOR
   }

*/